;;
;; cycle between adaptive, minor and major grid snapping
;; 9/2020 knut hohenberg / KHAD.eu
;; no rights reserved, no responsibility taken
;;
(defun cycle_gridsnap ( / var1 var2)
 (if (member 0 (getvar "GRIDUNIT"))
  (progn
   (textscr)
   (princ "\nGrid spacing may not be zero for this to work,")
   (princ "\nplease provide the minor grid lines interval.")
   (initget 7)
   (setq var1 (getreal "\nGrid spacing in x-direction: "))
   (initget 6)
   (setq var2 (getreal (strcat "\nGrid spacing in y-direction <" (rtos var1) ">: ")))
   (if (not var2) (setq var2 var1))
   (setvar "GRIDUNIT" (list var1 var2))
   (graphscr)
  )
 )
 (setvar "GRIDMODE" 1)
 (setvar "SNAPMODE" 1)
 (setq var2 (getvar "GRIDMAJOR"))
 (cond
  ((= 2 (logand 2 (setq var1 (getvar "GRIDDISPLAY"))))
   (setvar "GRIDDISPLAY" (- var1 2))
   (setvar "SNAPUNIT" (getvar "GRIDUNIT"))
   (setvar "SNAPTYPE" 0)
   (princ "\nSnap spacing set to minor grid lines")
  )
  ((= 2 (getvar "SNAPTYPE"))
   (setvar "SNAPUNIT" (getvar "GRIDUNIT"))
   (setvar "SNAPTYPE" 0)
   (princ "\nSnap spacing set to minor grid lines")
  )
  ((equal (getvar "SNAPUNIT") (setq var1 (getvar "GRIDUNIT")))
   (setvar "SNAPUNIT" (mapcar '* var1 (list var2 var2)))
   (setvar "SNAPTYPE" 0)
   (princ "\nSnap spacing set to major grid lines")
  )
  ((equal (getvar "SNAPUNIT") (mapcar '* (setq var1 (getvar "GRIDUNIT")) (list var2 var2)))
   (setvar "SNAPUNIT" var1)
   (if (/= 2 (logand 2 (setq var1 (getvar "GRIDDISPLAY"))))
    (setvar "GRIDDISPLAY" (+ var1 2))
   )
   (setvar "SNAPTYPE" 2)
   (princ "\nActivated adaptive grid and snap spacing")
  )
  (t
   (setvar "SNAPUNIT" (getvar "GRIDUNIT"))
   (setvar "SNAPTYPE" 0)
   (princ "\nSnap spacing set to minor grid lines")
  )
 )
 (princ)
)
